#include <LiquidCrystal.h>              //on définit la librairie LCD


LiquidCrystal lcd(8, 9, 4, 5, 6, 7); // on definit les broches du LCD

int lcd_key1    = 0;
int lcd_key2    = 0;
int adc_key_in1  = 0;
int adc_key_in2  = 0;
int choix2 = 0;
int choix3 = 0;
int laser = 12;
int capteurlaser; 
int capteurson;   
int relais = 11;
int seuillaser = 400;
int seuilson = 550;
int momentlaser = 0;
int momentson = 0;
int momentaction = 0;
int claser;
int cson;
int retardson = 100;
int retardlaser = 100;

unsigned long last_affichage;



#define btnRIGHT1  1
#define btnUP1     2
#define btnDOWN1   3
#define btnLEFT1   4
#define btnSELECT1 5
#define btnNONE1   6

#define btnRIGHT2  10
#define btnUP2     11
#define btnDOWN2   12
#define btnLEFT2   13
#define btnSELECT2 14
#define btnNONE2   15

int read_LCD_buttons1()
{
  adc_key_in1 = analogRead(0);      
  if (adc_key_in1 > 1000) return btnNONE1; //1000
  if (adc_key_in1 < 100)   return btnRIGHT1;  //50
  if (adc_key_in1 < 200)  return btnUP1; //250
  if (adc_key_in1 < 380)  return btnDOWN1; //380
  if (adc_key_in1 < 555)  return btnLEFT1; //555
  if (adc_key_in1 < 790)  return btnSELECT1;    //790
}

int read_LCD_buttons2()
{
  adc_key_in2 = analogRead(0);      
  if (adc_key_in2 > 1000) return btnNONE2; 
  if (adc_key_in2 < 100)   return btnRIGHT2;  
  if (adc_key_in2 < 200)  return btnUP2; 
  if (adc_key_in2 < 380)  return btnDOWN2; 
  if (adc_key_in2 < 555)  return btnLEFT2; 
  if (adc_key_in2 < 790)  return btnSELECT2;    
}

int animation()
{
  lcd.setCursor (0,0);
  lcd.print("----------------");
  lcd.setCursor (0,1);
  lcd.print("----------------");
  delay (300);
  lcd.clear();
  lcd.setCursor (0,0);
  lcd.print(" S--------------");
  lcd.setCursor (0,1);
  lcd.print(" P--------------");
  delay (300);
  lcd.clear();
  lcd.setCursor (0,0);
  lcd.print(" So-------------");
  lcd.setCursor (0,1);
  lcd.print(" Ph-------------");
  delay (300);
  lcd.clear();
  lcd.setCursor (0,0);
  lcd.print(" Sou------------");
  lcd.setCursor (0,1);
  lcd.print(" Pho------------");
  delay (300);
  lcd.clear();
  lcd.setCursor (0,0);
  lcd.print(" Soun------------");
  lcd.setCursor (0,1);
  lcd.print(" Phot------------");
  delay (300);
  lcd.clear();
  lcd.setCursor (0,0);
  lcd.print(" Sound----------");
  lcd.setCursor (0,1);
  lcd.print(" Photo----------");
  delay (300);
  lcd.clear();
  lcd.setCursor (0,0);
  lcd.print(" Sound ---------");
  lcd.setCursor (0,1);
  lcd.print(" Photo ---------");
  delay (300);
  lcd.clear();
  lcd.setCursor (0,0);
  lcd.print(" Sound &--------");
  lcd.setCursor (0,1);
  lcd.print(" Photo t--------");
  delay (300);
  lcd.clear();
  lcd.setCursor (0,0);
  lcd.print(" Sound & -------");
  lcd.setCursor (0,1);
  lcd.print(" Photo tr-------");
  delay (300);
  lcd.clear();
  lcd.setCursor (0,0);
  lcd.print(" Sound & l------");
  lcd.setCursor (0,1);
  lcd.print(" Photo tri------");
  delay (300);
  lcd.clear();
  lcd.setCursor (0,0);
  lcd.print(" Sound & la-----");
  lcd.setCursor (0,1);
  lcd.print(" Photo trig-----");
  delay (300);
  lcd.clear();
  lcd.setCursor (0,0);
  lcd.print(" Sound & las----");
  lcd.setCursor (0,1);
  lcd.print(" Photo trigg----");
  delay (300);
  lcd.clear();
  lcd.setCursor (0,0);
  lcd.print(" Sound & lase---");
  lcd.setCursor (0,1);
  lcd.print(" Photo trigge---");
  delay (300);
  lcd.clear();
  lcd.setCursor (0,0);
  lcd.print(" Sound & laser--");
  lcd.setCursor (0,1);
  lcd.print(" Photo trigger--");
  delay (300);
  lcd.clear();
  lcd.setCursor (0,0);
  lcd.print(" Sound & laser -");
  lcd.setCursor (0,1);
  lcd.print(" Photo trigger -");
  delay (300);
  lcd.clear();
  lcd.setCursor (0,0);
  lcd.print(" Sound & laser  ");
  lcd.setCursor (0,1);
  lcd.print(" Photo trigger  ");
  delay (2000);
  lcd.clear();
}

int lecturelaser()
{  
  while (momentlaser == 1)
  {  
    if ( millis() - last_affichage > 100) {
      capteurlaser = analogRead(A1);
      Serial.println (capteurlaser);
      lcd.setCursor (7,0);
      lcd.print (capteurlaser) ;
      lcd.setCursor (0,0);
      lcd.print("Laser:");
      lcd.setCursor (0,1);
      lcd.print("Seuil:");
      lcd.setCursor (7,1);
      lcd.print(seuillaser);
      last_affichage = millis();
      if (capteurlaser >seuillaser)
      {
        lcd.clear();
        lcd.print ("Photo ok");
        digitalWrite(laser, LOW);
        delay(retardlaser);
        digitalWrite(relais, HIGH); 
        delay(100);
        digitalWrite(relais, LOW);
        delay(3500);
        loop();
      }
    }
  }
}

int lectureson()
{
  while (momentson == 1)
  {
    capteurson = analogRead(A2);
    Serial.println (capteurson);
    lcd.setCursor(0,0);
    lcd.print ("Photo");
    lcd.setCursor(0,1);
    lcd.print ("en cours");
    if (capteurson >seuilson)
    {
      lcd.clear();
      lcd.print ("Photo ok");
      delay(retardson);
      digitalWrite(relais, HIGH); 
      delay(100);
      digitalWrite(relais, LOW);
      delay(3500);
      loop();  
    }
  }
}  


// On définit ce qui sera fait par "fonctionson"
int fonctionson()

{ 
  lcd.clear();
  momentson = 1;
  lectureson();
}


// On définit ce qui sera fait par "fonctionlaser"
int fonctionlaser()

{
  lcd.clear();
  momentlaser = 1;
  lecturelaser();
}


int Action2() 
{
  switch(choix3)   {
  case 2:              
    {
      fonctionson();
      break;
    } 

  case 1:
    {
      fonctionlaser();
      break;
    }
  }
}


int calibrageson()  
{    
  while (cson == 1)
  {
    if ( millis() - last_affichage > 1000) {
      capteurson = analogRead(A2);
      Serial.println (capteurson);
      choix3 = 2;
      lcd.clear();
      lcd.setCursor (0,0);
      lcd.print ("Retard:");
      lcd.setCursor (9,0);
      lcd.print (retardson) ;
      lcd.setCursor (0,1);
      lcd.print("Seuil:");
      lcd.setCursor(8,1);
      lcd.print(seuilson);
      lcd.setCursor(12,1);
      lcd.print(capteurson);
      last_affichage = millis();
    }
    {   
      lcd_key2 = read_LCD_buttons2() ;
      switch (lcd_key2)  {
      case btnSELECT2:    
        {    
          Action2();
          break;
        }

      case btnUP2:
        {
          seuilson = seuilson+10;
          delay(400);
          break;
        }

      case btnDOWN2:
        {   
          seuilson = seuilson-10;
          delay(400);
          break;  
        }

      case btnLEFT2:
        {
          retardson = retardson-100;
          delay(400);
          break;
        }

      case btnRIGHT2:
        {
          retardson = retardson+100;
          delay(400);
          break;
        }
      };
    }
  }  
}

int calibragelaser()  
{    
  while (claser == 1)
  {
    if ( millis() - last_affichage > 1000) {
      capteurlaser = analogRead(A1);
      Serial.println (capteurlaser);
      digitalWrite(laser, HIGH);
      lcd.clear();
      choix3 = 1;
      lcd.setCursor (0,0);
      lcd.print ("Retard:");
      lcd.setCursor (9,0);
      lcd.print (retardlaser) ;
      lcd.setCursor (0,1);
      lcd.print("Seuil:");
      lcd.setCursor(8,1);
      lcd.print(seuillaser);
      lcd.setCursor(12,1);
      lcd.print(capteurlaser);
      last_affichage = millis();
    }
    {   
      lcd_key2 = read_LCD_buttons2() ;
      switch (lcd_key2)  {
      case btnSELECT2:    
        {    
          Action2();
          break;
        }

      case btnUP2:
        {
          seuillaser = seuillaser+10;
          delay(200);
          break;
        }

      case btnDOWN2:
        {   
          seuillaser = seuillaser-10;
          delay(200);
          break;  
        }

      case btnLEFT2:
        {
          retardlaser = retardlaser-100;
          delay(200);
          break;
        }

      case btnRIGHT2:
        {
          retardlaser = retardlaser+100;
          delay(200);
          break;
        }
      };
    }
  }  
}

int calibrage()
{ 
  switch(choix2)   {
  case 1:              
    {
      cson = 1;
      calibrageson();
      break;
    } 

  case 2:
    { 
      claser = 1;
      calibragelaser();
      break;
    }
  }
}

int menucalibrage()                                    // Menu de démarrage
{  
  lcd.setCursor (2,0);
  lcd.print ("Son");
  lcd.setCursor (2,1);
  lcd.print ("Laser");  

  lcd_key1 = read_LCD_buttons1() ;
  switch (lcd_key1)  {
  case btnSELECT1:    
    {    
      calibrage();
      break;
    }

  case btnUP1:
    {
      digitalWrite(laser, LOW);
      lcd.clear();     
      lcd.setCursor (2,0);
      lcd.print ("Son");
      lcd.setCursor (2,1);
      lcd.print ("Laser"); 
      choix2= 1;     
      Serial.println(choix2);
      lcd.setCursor (0,0);
      lcd.print ((char)126);
      lcd.setCursor (0,1);
      lcd.print (' ');
      break;
    }

  case btnDOWN1:
    {   
      digitalWrite(laser, LOW);  
      lcd.clear() ;    
      lcd.setCursor (2,0);
      lcd.print ("Son");
      lcd.setCursor (2,1);
      lcd.print ("Laser"); 
      choix2= 2;    
      Serial.println(choix2);
      lcd.setCursor (0,1);
      lcd.print ((char)126);
      lcd.setCursor (0,0);
      lcd.print (' ');
      break;  
    }
  };
}

int accueil()
{
  lcd.setCursor(0,0);
  lcd.print("Declencheur");
  lcd.setCursor(0,1);
  lcd.print("photo");
}


void setup()
{
  pinMode(laser, OUTPUT);  
  pinMode(relais, OUTPUT);
  int capteurlaser = A1;
  int caplaser = analogRead(capteurlaser);
  int capteurson = A2;
  int capson = analogRead(capteurson);
  Serial.begin(115200);
  lcd.begin(16, 2); 
  animation();
  lcd.clear();
}


void loop()
{
  if ( millis() - last_affichage > 1000) {
    calibrageson();
    calibragelaser();
    lecturelaser();
    lectureson();
    last_affichage = millis(); 
  }

  menucalibrage(); 
}


